--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.



USE Adventureworks

SELECT * FROM Person.Person

SELECT p.BusinessEntityID + p.LastName FROM Person.Person AS p
-- https://docs.microsoft.com/en-us/sql/t-sql/data-types/data-type-precedence-transact-sql

SELECT CAST(p.BusinessEntityID AS nvarchar(10)) + p.LastName FROM Person.Person AS p
SELECT CONCAT(p.BusinessEntityID, p.LastName) FROM Person.Person AS p
SELECT CONCAT_WS(', ', p.BusinessEntityID, p.LastName) FROM Person.Person AS p


------------------------------------------------------------------------------------------------------------------------------------------------------
--ISNUMERIC, ISDATE och TRY_CAST (eller TRY_CONVERT om ni fredrar)

IF OBJECT_ID('t_n') IS NOT NULL DROP TABLE t_n

CREATE TABLE t_n(c1 int identity, myNumber varchar(20), myDate varchar(30))

INSERT INTO t_n(myNumber, myDate)
VALUES
 ('3',		'20120212')				--OK
,('SQL',	'hej')					--Helt uppt vggarna
,('234231', '20890101')				--Fr stort fr smallint/smalldatetime
,('1E3',	'17500112')				--OK som float, fr litet fr datetime
,('1D2',	'20150223 14:23:05')	--OK som float


SELECT * FROM t_n

--Vi vill ha myNumber som int
SELECT c1, CAST(myNumber AS int)
FROM t_n
--Gick inte, error

--Vi vill ha myDate som smalldatetime
SELECT c1, CAST(myDate AS smalldatetime)
FROM t_n
--Gick inte, error


--Vad sger ISNUMERIC respektive ISDATE?
SELECT 
 c1
,myNumber
,ISNUMERIC(myNumber) AS rNumerisk
,myDate
,ISDATE(myDate) AS rDatum
FROM t_n


--Jahapp,. d filterar vi vl bort de som inte r numeriska 
--och konverterar resten till int!
SELECT c1, myNumber, CAST(myNumber AS int)
FROM t_n
WHERE ISNUMERIC(myNumber) = 1
--Nej...

--TRY_CAST till rddning (2012)!
SELECT
 c1
, myNumber
,ISNUMERIC(myNumber) AS is_numeric_
,TRY_CAST(myNumber AS int) AS OK_int
,TRY_CAST(myNumber AS smallint) AS OK_smallint
,TRY_CAST(myNumber AS float) AS OK_float
FROM t_n
WHERE TRY_CAST(myNumber AS int) IS NOT NULL

SELECT
 c1
, myDate
,ISDATE(myDate) AS is_date_
,TRY_CONVERT(smalldatetime, myDate) AS OK_smalldatetime
,TRY_CONVERT(datetime, myDate) AS OK_datetime
,TRY_CONVERT(datetime2(0), myDate) AS OK_datetime2
FROM t_n
