--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb;

DROP TABLE IF EXISTS TestGuidRnd
DROP TABLE IF EXISTS TestGuidSeq
DROP TABLE IF EXISTS FloatTest

-----------------------------------------------------------------------------------------------------------------------------------------------------------
--Heltal
-----------------------------------------------------------------------------------------------------------------------------------------------------------
DECLARE @a smallint
SET @a = 47
SELECT @a
GO

DECLARE @a smallint
SET @a = 827346
SELECT @a
GO

--bit
DECLARE @a bit
SET @a = 0
SELECT @a
GO

DECLARE @a bit
SET @a = 1
SELECT @a
GO

DECLARE @a bit
SET @a = 42
SELECT @a
GO

DECLARE @a bit
SET @a = 'false'
SELECT @a
GO

DECLARE @a bit
SET @a = 'true'
SELECT @a
GO

WHERE isVIP

WHERE isVIP = 1

GO

-----------------------------------------------
--decimal/numeric
DECLARE @a decimal(5, 2)
SET @a = 123.45
SELECT @a
GO
-- -999.99
-- +999.99


-----------------------------------------------------------------------------------------------------------------------------------------------------------
--Float och real
-----------------------------------------------------------------------------------------------------------------------------------------------------------
SELECT CAST(3.1 AS float)
--r vrdet verkligen 3.1? Kolla med SQLCMD.EXE.

--Eller vi tar det som decimal
SELECT CAST(CAST(3.1 AS float) AS decimal(38,29))

--Float eller real?
CREATE TABLE FloatTest(c1 float(24), c2 float(25))
EXEC sp_help 'FloatTest'


-----------------------------------------------------------------------------------------------------------------------------------------------------------
--Tabell med uniqueidentifier
--Tv varianter fr att generera vrde
-----------------------------------------------------------------------------------------------------------------------------------------------------------

--Nedan r "random" fysiskt
SELECT NEWID()
SELECT NEWID()
SELECT NEWID()
SELECT NEWSEQUENTIALID()

DROP TABLE IF EXISTS TestGuid
GO
CREATE TABLE TestGuid
(
  orderDate date,
  theGuidNewid uniqueidentifier NOT NULL DEFAULT NEWID(),
  theGuidSeq uniqueidentifier NOT NULL DEFAULT NEWSEQUENTIALID() ,
  INDEX ix_theGuidNewId(theGuidNewid),
  INDEX ix_theGuidSeq(theGuidSeq),
);

INSERT INTO dbo.TestGuid (OrderDate) VALUES ('2011-05-23')
INSERT INTO dbo.TestGuid (OrderDate) VALUES ('2011-05-13')
INSERT INTO dbo.TestGuid (OrderDate) VALUES ('2011-05-29')
SELECT * FROM TestGuid

SELECT CAST('DF328C80-8D1D-4293-B655-EBC7D0A87546' AS uniqueidentifier)
SELECT CAST('hej' AS uniqueidentifier)


--Fr skojs skull, slng in ett gng rader och kolla fragmentering
ALTER DATABASE tempdb MODIFY FILE(name = tempdev, SIZE = 50MB)
ALTER DATABASE tempdb MODIFY FILE(name = templog, SIZE = 100MB)

SET NOCOUNT ON
DECLARE @i int = 1
WHILE @i <= 100000
BEGIN
 INSERT INTO TestGuid (orderDate) 
 VALUES (SYSDATETIME())
 SET @i += 1
END
GO

SELECT OBJECT_NAME(object_id), avg_fragmentation_in_percent, page_count, avg_page_space_used_in_percent, record_count, *
FROM sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, 'DETAILED')
WHERE OBJECT_NAME(object_id) = 'TestGuid'
 AND index_level = 0
 AND index_type_desc = 'NONCLUSTERED INDEX'

-----------------------------------------------------------------------------------------------------------------------------------------------------------
--NULL och utelmnade vrden
-----------------------------------------------------------------------------------------------------------------------------------------------------------

CREATE TABLE dbo.Opportunity
( 
  Requirements nvarchar(50) NOT NULL,
  ReceivedDate date NOT NULL,
  LikelyClosingDate date NULL,
  SalespersonID int NULL,
  Rating int NOT NULL
)

INSERT INTO dbo.Opportunity 
       (Requirements, ReceivedDate,  LikelyClosingDate,              SalespersonID, Rating)
VALUES ('n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 34,            9),
       ('n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 37,            2);


SELECT * FROM dbo.Opportunity;


--NULL fr LikelyClosingDate, ange ej i listan
INSERT dbo.Opportunity 
       (Requirements, ReceivedDate,  SalespersonID, Rating)
VALUES ('n.d.'      , SYSDATETIME(), 72            ,8);

SELECT * FROM dbo.Opportunity;

--NULL fr LikelyClosingDate, ange NULL i listan
INSERT dbo.Opportunity 
       (Requirements, ReceivedDate,  SalespersonID, Rating, LikelyClosingDate)
VALUES ('n.d.'      , SYSDATETIME(), 72            ,8,      NULL);

SELECT * FROM dbo.Opportunity;


--NULL fr Rating? 
INSERT dbo.Opportunity (Requirements, ReceivedDate,  SalespersonID)
VALUES                 ('n.d.',       SYSDATETIME(), 72);

SELECT * 
FROM dbo.Opportunity
WHERE LikelyClosingDate IS NULL



CREATE TABLE dbo.x
( 
  Requirements nvarchar(50) --Tillter denna null?
)



USE Adventureworks

SELECT p.Name, *
FROM Production.Product AS p


SELECT p.Name, 'Priset r ' + p.ListPrice 
FROM Production.Product AS p

--Data type precedence

SELECT p.Name, 'Priset r ' + CAST(p.ListPrice AS varchar(20))
FROM Production.Product AS p

SELECT p.Name, CONCAT('Priset r ', p.ListPrice)
FROM Production.Product AS p


--Finns ven CONVERT()