--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

--Lite exempel p syntax fr constraints
USE tempdb
IF OBJECT_ID('t1') IS NOT NULL DROP TABLE t1
IF OBJECT_ID('t2') IS NOT NULL DROP TABLE t2
IF OBJECT_ID('t3') IS NOT NULL DROP TABLE t3
IF OBJECT_ID('t4') IS NOT NULL DROP TABLE t4

--------------------------------------------------------------------------------------------
--CREATE TABLE, Column level
--------------------------------------------------------------------------------------------
CREATE TABLE t1(
 c1 int NOT NULL PRIMARY KEY
,c2 CHAR(5))
GO
--Men, inget bra namn:
EXEC sp_helpconstraint 't1'

--Namngiven
CREATE TABLE t2(
 c1 int NOT NULL CONSTRAINT PK_t2 PRIMARY KEY
,c2 CHAR(5))
GO
EXEC sp_helpconstraint 't2'
EXEC sp_help 't2'
GO

--Vill referera till flera kolumner:
CREATE TABLE t3
(
 c1 int
,c2 int CONSTRAINT CK_t3_c2_gt_c1 CHECK(c2 > c1)
)
GO
--Ovan gr ej

--------------------------------------------------------------------------------------------
--CREATE TABLE, Table level
--------------------------------------------------------------------------------------------
CREATE TABLE t3
(
 c1 int
,c2 int 
,CONSTRAINT CK_t3_c2_gt_c1 CHECK(c2 > c1)
)

--Verifiera
INSERT INTO t3(c1, c2) VALUES(5, 2)


--------------------------------------------------------------------------------------------
--Lgg till i efterhand
--------------------------------------------------------------------------------------------
DROP TABLE IF EXISTS t4
GO

CREATE TABLE t4
(
 c1 int
,c2 int
)


INSERT INTO t4(c1, c2) VALUES(5, 2)

SELECT * FROM t4

ALTER TABLE t4 --WITH NOCHECK 
ADD CONSTRAINT CK_t4_c2_gt_c1 CHECK(c2 > c1)

DELETE FROM t4

ALTER TABLE t4
ADD CONSTRAINT CK_t4_c2_gt_c1 CHECK(c2 > c1)

EXEC sp_helpconstraint 't4'

SELECT * FROM t4

--Verifiera
INSERT INTO t4(c1, c2) VALUES(5, 2)

--Ta bort constraint
ALTER TABLE t4
 DROP CONSTRAINT CK_t4_c2_gt_c1
