--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb

CREATE TABLE dbo.Customer
(
CustomerID int IDENTITY(1,1) PRIMARY KEY,
CustomerName nvarchar(50) NOT NULL
)

INSERT dbo.Customer VALUES ('Marcin Jankowski'),('Darcy Jayne');

SELECT * FROM dbo.Customer

CREATE TABLE dbo.CustomerOrder
(
CustomerOrderID int IDENTITY(1,1) PRIMARY KEY,
CustomerID int NOT NULL FOREIGN KEY REFERENCES dbo.Customer (CustomerID), --Ej angivet medfr NO ACTION
OrderAmount decimal(18,2) NOT NULL
)


SELECT * FROM dbo.Customer;
SELECT * FROM dbo.CustomerOrder


INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (1, 12.50)
INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (2, 14.70)
INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (2, 99.90)


SELECT * FROM dbo.Customer
SELECT * FROM dbo.CustomerOrder


--Error:
INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (99, 15.50)

--Error:
--DELETE FROM dbo.CustomerOrder WHERE CustomerID = 1
DELETE FROM dbo.Customer WHERE CustomerID = 1


EXEC sp_helpconstraint 'dbo.CustomerOrder'
EXEC sp_helpconstraint 'dbo.Customer'

--Query builder anvnder FK fr att gra join

SELECT * FROM Customer AS c 
 INNER JOIN CustomerOrder AS co ON c.CustomerID = co.CustomerID

--Ta bort ovan constraint
ALTER TABLE dbo.CustomerOrder
  DROP CONSTRAINT FK__CustomerO__Custo__5812160E

--Lgg till igen, med CASCADE
ALTER TABLE dbo.CustomerOrder
-- WITH NOCHECK
  ADD CONSTRAINT FK_CustomerOrder_Customer
  FOREIGN KEY (CustomerID) 
  REFERENCES dbo.Customer (CustomerID)
  ON DELETE CASCADE
  ON UPDATE NO ACTION

SELECT * FROM dbo.Customer
SELECT * FROM dbo.CustomerOrder

--Cascading delete
DELETE FROM dbo.Customer WHERE CustomerID = 2

--Finns ocks SET DEFAULT och SET NULL

SELECT * FROM dbo.Customer
SELECT * FROM dbo.CustomerOrder


DROP TABLE dbo.Customer
TRUNCATE TABLE Customer

ALTER TABLE dbo.CustomerOrder NOCHECK CONSTRAINT FK_CustomerOrder_Customer --disable
INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (3, 15.50)
ALTER TABLE dbo.CustomerOrder CHECK CONSTRAINT FK_CustomerOrder_Customer --enable, validera INTE befintligt data
INSERT INTO dbo.CustomerOrder (CustomerID, OrderAmount) VALUES (4, 15.50)
ALTER TABLE dbo.CustomerOrder WITH CHECK CHECK CONSTRAINT FK_CustomerOrder_Customer --enable, validera INTE befintligt data

DBCC CHECKCONSTRAINTS(CustomerOrder)

SELECT * FROM sys.foreign_keys

ALTER TABLE dbo.CustomerOrder WITH CHECK CHECK CONSTRAINT FK_CustomerOrder_Customer --enable

--Lgg till en constraint utan att checka befintligt data
ALTER TABLE x ADD CONSTRAINT WITH NOCHECK ....

SELECT * FROM dbo.Customer
SELECT * FROM dbo.CustomerOrder


--Sammansatt PK, och FK
CREATE TABLE t(c1 int, c2 int, c3 int, CONSTRAINT pk_t PRIMARY KEY(c1, c2))
CREATE TABLE rf(rfc1 int, rfc2 int, c1 int, c2 int, CONSTRAINT FK_x FOREIGN KEY (c1, c2) REFERENCES t(c1, c2))
