--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb
GO

---------------------------------------------------------------------------------------------------------
--Tabell med identity
---------------------------------------------------------------------------------------------------------
DROP TABLE IF EXISTS dbo.Opportunity
GO

CREATE TABLE dbo.Opportunity
( 
  OpportunityID int NOT NULL IDENTITY(1,1) PRIMARY KEY,
  Requirements nvarchar(50) NOT NULL,
  ReceivedDate date NOT NULL,
  LikelyClosingDate date NULL,
  SalespersonID int NULL,
  Rating int NOT NULL
);

INSERT INTO dbo.Opportunity 
       (Requirements, ReceivedDate,  LikelyClosingDate,              SalespersonID, Rating)
VALUES ('n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 34,            9),
       ('n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 37,            2);

SELECT * FROM dbo.Opportunity ORDER BY OpportunityID

--Senast genererade identity?
SELECT SCOPE_IDENTITY()

--Finns ocks @@IDENTITY funktionen, anvnd inte

SELECT * FROM dbo.Opportunity;

--Kan ej ange vrde fr IDENTITY kolumn (se dock SET IDENTITY_INSERT)
INSERT INTO dbo.Opportunity 
       (OpportunityID, Requirements, ReceivedDate,  LikelyClosingDate,              SalespersonID, Rating)
VALUES (5,             'n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 34,            9)

--Tillta att ange att vrde fr identity kolumn vid INSERT
SET IDENTITY_INSERT dbo.Opportunity ON
SET IDENTITY_INSERT dbo.Opportunity OFF

DELETE FROM dbo.Opportunity WHERE OpportunityID = 3
DELETE FROM dbo.Opportunity WHERE OpportunityID > 6

SELECT * FROM dbo.Opportunity ORDER BY OpportunityID


INSERT INTO dbo.Opportunity 
       (Requirements, ReceivedDate,  LikelyClosingDate,              SalespersonID, Rating)
VALUES ('n.d.',       SYSDATETIME(), DATEADD(month,1,SYSDATETIME()), 34,            9)

--2019
SELECT * FROM sys.database_scoped_configurations
WHERE name = 'IDENTITY_CACHE'

--Kolla eller ndra, anvnds sllan
DBCC CHECKIDENT('Opportunity')
DBCC CHECKIDENT('Opportunity', RESEED, 10)

SELECT * FROM dbo.Opportunity

TRUNCATE TABLE dbo.Opportunity --terstller/"nollar" identity
DELETE FROM tbl --"Delete utan WHERE" nollar INTE identity

--Har en tabell en kolumn med identity egenskapen
EXEC sp_help 'dbo.Opportunity'

