--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb;
GO

CREATE TABLE ProspectiveHire
(
 ID int NOT NULL
,FirstName nvarchar(30) NOT NULL
,LastName nvarchar(30) NOT NULL
,CountryCode nchar(3) NOT NULL
	CONSTRAINT CHK_ProspectiveHire_CountryCode_Length3 CHECK (LEN(CountryCode) = 3)
,StateOrRegion nvarchar(20) NULL
,DateOfBirth date NOT NULL
	CONSTRAINT CHK_ProspectiveHire_DateOfBirth_NotFuture CHECK (DateOfBirth < SYSDATETIME())
,LikelihoodOfJoining tinyint NOT NULL
	CONSTRAINT CHK_ProspectiveHire_LikelihoodOfJoining_Range1To5 CHECK (LikelihoodOfJoining BETWEEN 1 AND 5)
	CONSTRAINT DF_ProspectiveHire_LikelihoodOfJoining DEFAULT (3)
,CONSTRAINT CHK_ProspectiveHire_US_States_Length2 CHECK (CountryCode <> N'USA' OR LEN(StateOrRegion) = 2)
);
GO

--Alla kolumner OK:
INSERT INTO dbo.ProspectiveHire 
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES (1,	'Jon',		'Jaffe',	'USA',			'WA',			'19730402',		4);

SELECT * FROM dbo.ProspectiveHire;


--Otillten NULL (FirstName)
INSERT INTO dbo.ProspectiveHire 
      (ID,	FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES(2,	NULL,		'Jacobsen', 'USA',			'W',			'19730405',		2);


--Fel lngd p Country Code
INSERT INTO dbo.ProspectiveHire		--OBS
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES (2,	'Lola',		'Jacobsen', 'US ',			'WA',			'19730405',		2);


--Date of birth test
INSERT INTO dbo.ProspectiveHire										--OBS
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES (2, 'Lola',		'Jacobsen', 'USA',			'WA',			'20600405',		2);


--US State length test
INSERT INTO dbo.ProspectiveHire 
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES (2, 'Lola',		'Jacobsen', 'USA',			'W',			'19730405',		2);


--Default constraint, utelmna kolumnen
INSERT INTO dbo.ProspectiveHire 
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth)
VALUES (5, 'Lola',		'Jacobsen', 'USA',			'WA',			'19730405');

--Default constraint, ange DEFAULT nyckelord
INSERT INTO dbo.ProspectiveHire 
       (ID, FirstName,	LastName,	CountryCode,	StateOrRegion,	DateOfBirth,	LikelihoodOfJoining)
VALUES (6, 'Lola',		'Jacobsen', 'USA',			'WA',			'19730405',     DEFAULT);

SELECT * FROM ProspectiveHire

--sys.sysconstraints
SELECT
 OBJECT_NAME(id) AS TableName
,OBJECT_NAME(constid) AS ConstraintName
,* 
FROM sys.sysconstraints

SELECT * FROM sys.check_constraints
SELECT * FROM sys.default_constraints

EXEC sp_helpconstraint 'dbo.ProspectiveHire'
EXEC sp_help 'dbo.ProspectiveHire'
SELECT * FROM dbo.ProspectiveHire


--Exempel p check constraint fr personnummer, med hypotetisk function for att verifiera checksiffra (sista siffran)
'19750623-4567'

...
pnr CHECK(	pnr LIKE '[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]-[0-9][0-9][0-9][0-9]'
			AND dbo.checkpnr(pnr) = 1
		)


