--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE tempdb;
SET NOCOUNT ON;
DROP TABLE IF EXISTS dbo.PhoneLog
GO

---------------------------------------------------------------------------------------------------------------------------
--Klustrat index 

--PK klustrad
CREATE TABLE dbo.PhoneLog
( PhoneLogID int IDENTITY(1,1) PRIMARY KEY,
  LogRecorded datetime2 NOT NULL,
  PhoneNumberCalled nvarchar(100) NOT NULL,
  CallDurationMs int NOT NULL
) 

SELECT * FROM sys.indexes WHERE OBJECT_NAME(object_id) = N'PhoneLog';
SELECT * FROM sys.key_constraints WHERE OBJECT_NAME(parent_object_id) = N'PhoneLog';

--Visa OE
EXEC sp_helpindex 'dbo.PhoneLog'
EXEC sp_indexinfo 'Phonelog'	--finns p min hemsida



--Ladda data
INSERT INTO dbo.PhoneLog (LogRecorded, PhoneNumberCalled, CallDurationMs)
SELECT TOP(10000) SYSDATETIME(), '999-9999', CAST(RAND() * 1000 AS int) FROM sys.columns a, sys.columns b

SELECT * FROM dbo.PhoneLog

---------------------------------------------------------------------------------------------------------------------------
--NC index
USE Adventureworks

SELECT * FROM Person.Person

EXEC sp_helpindex 'Person.Person'
EXEC sp_indexinfo 'Person' --Finns p min web-site

--Selektivitet?
SELECT Title, COUNT(*) AS antal
FROM Person.Person
GROUP BY Title
ORDER BY antal
---------------------------------------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------------
SELECT * FROM Person.Person WHERE Title = 'Sr.'					--   11 rader
SELECT * FROM Person.Person WHERE Title = 'Ms.'					--  415 rader
SELECT * FROM Person.Person WHERE Title = 'Mr.'					--  577 rader
SELECT * FROM Person.Person WHERE Title IS NULL 				--18963 rader
SELECT * FROM Person.Person WITH(INDEX(x)) WHERE Title IS NULL	--18963 rader

--Icke-klustrat index fr att understda ovan:
CREATE NONCLUSTERED INDEX x ON Person.Person(title)

CREATE INDEX x ON Person.Person(title)
 WITH DROP_EXISTING

SET STATISTICS IO ON
-------------------------------------------------------------------------------------------------
