--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
SET STATISTICS IO ON


IF OBJECT_ID('sod') IS NOT NULL DROP TABLE sod
GO

SELECT SalesOrderID, SalesOrderDetailID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate--, CAST('hej' AS char(100)) AS filler
INTO sod
FROM Sales.SalesOrderDetail

INSERT INTO sod (SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate)
SELECT SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate--, CAST('hej' AS char(100)) AS filler
FROM sod

INSERT INTO sod (SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate)
SELECT SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate--, CAST('hej' AS char(100)) AS filler
FROM sod

INSERT INTO sod (SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate)
SELECT SalesOrderID, CarrierTrackingNumber, OrderQty, ProductID, SpecialOfferID, UnitPrice, UnitPriceDiscount, LineTotal, rowguid, ModifiedDate--, CAST('hej' AS char(100)) AS filler
FROM sod

--Vi ska leka med denna tabell
SELECT TOP(10) * FROM sod
SELECT COUNT(*) FROM sod

--Mt I/O kostnad
SET STATISTICS IO ON

--Exempel p frga, utan index. ca 12000 pages.
SELECT * FROM sod WHERE OrderQty = 34

--Understd med index p OrderQty
CREATE NONCLUSTERED INDEX x ON sod(OrderQty)

--27 pages
SELECT * FROM sod WHERE OrderQty = 34

--Tvinga scan, med "optimizer hint", i detta fall en sk "table hint" (finns ocks "query hint" och "join hint").
SELECT * FROM sod WITH (INDEX (0)) WHERE OrderQty = 34 --SARG, men vi tvingar en table scan


--Denna frga r viktig fr oss. Notera villkoret.
SELECT * FROM sod WHERE OrderQty * 3 = 144
--Fick en scan p indexet, inte en seek. Sen gjordes en lokkup fr varje rad.


--Fr vi en SEEK fr indexet?
SELECT * FROM sod WHERE OrderQty = 34 --SARG
SELECT * FROM sod WHERE OrderQty * 3 = 144 --ej SARG

--Alternativ frgeformulering
SELECT * FROM sod WHERE OrderQty  = 144/3 --SARG (144/3 blir till "constant folding" vid exekvering)

--Undvik utrkningar etc p kolumnsidan!!!!

--Computed column
ALTER TABLE sod ADD OrderQtyTimes3 AS OrderQty * 3

SELECT * FROM sod

--Och index p denna
CREATE INDEX x2 ON sod(OrderQtyTimes3)

--Anvnds indexet?
SELECT * FROM sod WHERE OrderQtyTimes3 = 144

SELECT * FROM sod WHERE OrderQty * 3 = 144 OPTION(RECOMPILE)



--Stda
DROP TABLE sod


