--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

-----------------------------------------------------------------------------------------------------------------------------------------------------------
--Jobba med exekveringsplaner

--Returnera plan som XML
SET SHOWPLAN_XML ON
SELECT ProductID, Name, Color 
FROM Production.Product
WHERE Color IN ('Blue','Red')
ORDER BY Name;
SET SHOWPLAN_XML OFF

--Kr query och returnera plan
SET STATISTICS XML ON
SELECT ProductID, Name, Color 
FROM Production.Product
WHERE Color IN ('Blue','Red')
ORDER BY Name;
SET STATISTICS XML OFF

--Display Estimated Execution Plan
SELECT ProductID, Name, Color 
FROM Production.Product
WHERE Color IN ('Blue','Red')
ORDER BY Name;


--Include Actual Execution Plan
SELECT ProductID, Name, Color 
FROM Production.Product
WHERE Color IN ('Blue','Red')
ORDER BY Name;
--Execution Plan tab

--"Show Execution Plan XML"
--"Save Execution Plan As"

-----------------------------------------------------------------------------------------------------------------------------------------------------------
--Vanliga element i exekveringsplaner

SET STATISTICS IO ON

--TS
EXEC sp_helpindex 'dbo.DatabaseLog'
SELECT * FROM dbo.DatabaseLog
SELECT * FROM dbo.DatabaseLog WHERE Event = 'CREATE_TABLE'


--CL IX scan
EXEC sp_indexinfo 'Person'
SELECT * FROM Person.Person;

--CL IX Seek
SELECT * FROM Person.Person 
WHERE BusinessEntityId = 12;

SELECT * FROM Person.Person 
WHERE BusinessEntityId BETWEEN 12 AND 27
--ORDER BY BusinessEntityID DESC
ORDER BY FirstName

SELECT * FROM Person.Person 
WHERE BusinessEntityId BETWEEN 12 AND 45
AND FirstName LIKE 'James%'
ORDER BY FirstName --Hupp!!!

--Non clustered index seek
SELECT * 
FROM Person.Person 
WHERE FirstName LIKE 'James';

-- Join typer
SELECT od.LineTotal, oh.BillToAddressId, od.ModifiedDate
FROM Sales.SalesOrderDetail AS od
 INNER JOIN Sales.SalesOrderHeader AS oh
  ON od.SalesOrderID = oh.SalesOrderID
WHERE od.LineTotal = 2039.994000
--WHERE oh.SubTotal > 3000
--CREATE INDEX x ON Sales.SalesOrderDetail(LineTotal)
--DROP indEX x ON Sales.SalesOrderDetail


-- Join typer
SELECT c.CustomerID
FROM Sales.SalesOrderDetail AS od
 INNER JOIN Sales.SalesOrderHeader AS oh  ON od.SalesOrderID = oh.SalesOrderID
 INNER JOIN Sales.Customer AS c ON oh.CustomerID = c.CustomerID
-- OPTION (FORCE ORDER)
GO


