--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

---------------------------------------------------------------------------------------------------------
--Skapa och anvnd vy
---------------------------------------------------------------------------------------------------------
CREATE VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN';
GO

SELECT * FROM Person.Individuals;

SELECT * 
FROM Person.Individuals 
ORDER BY Title, BusinessEntityID;
GO

--Kan inte ha ORDER BY i vy-definitionen
CREATE VIEW Person.Individuals2
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
ORDER BY Title, BusinessEntityID;
GO

SELECT OBJECT_DEFINITION(OBJECT_ID(N'Person.Individuals',N'V'));

EXEC sp_helptext 'Person.Individuals'
--Visa befintlig vy i SSMS
--Script
--Designer
GO

---------------------------------------------------------------------------------------------------------
--Alter
---------------------------------------------------------------------------------------------------------
ALTER VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
GO

SELECT * FROM Person.Individuals
GO

---------------------------------------------------------------------------------------------------------
--DROP och CREATE istllet fr ALTER
---------------------------------------------------------------------------------------------------------
IF OBJECT_ID('Person.Individuals') IS NOT NULL
 DROP VIEW Person.Individuals
GO

--Modernare
DROP VIEW IF EXISTS Person.Individuals
GO
CREATE VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
GO

---------------------------------------------------------------------------------------------------------
--i 2016 fick vi DROP IF EXISTS
---------------------------------------------------------------------------------------------------------
DROP VIEW IF EXISTS Person.Individuals
GO
CREATE VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
GO

---------------------------------------------------------------------------
--Eller dummy 'create or replace'
CREATE VIEW Person.Individuals
AS
SELECT 1 AS x
GO

ALTER VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
GO
---------------

---------------------------------------------------------------------------
--Eller i 2016 med SP1:
CREATE OR ALTER VIEW Person.Individuals
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN'
GO
---------------

---------------------------------------------------------------------------------------------------------
--WITH ENCRYPTION
---------------------------------------------------------------------------------------------------------
ALTER VIEW Person.Individuals
WITH ENCRYPTION
AS
SELECT BusinessEntityID, Title, FirstName, MiddleName, LastName 
FROM Person.Person AS p
WHERE p.PersonType = 'IN';
GO

SELECT OBJECT_DEFINITION(OBJECT_ID(N'Person.Individuals',N'V'));
GO

DROP VIEW Person.Individuals;
GO

