--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

IF OBJECT_ID('sod') IS NOT NULL DROP TABLE dbo.sod
SELECT *, CAST('hej' AS char(500)) AS filler INTO dbo.sod FROM Sales.SalesOrderDetail


SELECT TOP(100) * FROM dbo.sod
SELECT COUNT(*) FROM dbo.sod
SELECT COUNT(DISTINCT SpecialOfferID) FROM dbo.sod

SET STATISTICS IO ON

SELECT SpecialOfferID, COUNT(*) AS #antal, AVG(UnitPrice) AS avgPrice
FROM dbo.sod AS l 
GROUP BY SpecialOfferID
GO

--Skapa vy enligt ovan
CREATE VIEW ProdStats AS
SELECT SpecialOfferID, COUNT(*) AS #antal, AVG(UnitPrice) AS avgPrice
FROM dbo.sod AS l 
GROUP BY SpecialOfferID
GO

SELECT * FROM ProdStats

--Skapa index p ovan vy
CREATE UNIQUE CLUSTERED INDEX x ON ProdStats(SpecialOfferID)
GO

--Schemabind
ALTER VIEW dbo.ProdStats
 WITH SCHEMABINDING AS
SELECT SpecialOfferID, COUNT(*) AS #antal, AVG(UnitPrice) AS avgPrice
FROM dbo.sod AS l 
GROUP BY SpecialOfferID
GO

DROP TABLE dbo.sod

--Skapa index p ovan vy
CREATE UNIQUE CLUSTERED INDEX x ON ProdStats(SpecialOfferID)
GO

--Anvnd COUNT_BIG() istllet fr COUNT och SUM istllet fr AVG
ALTER VIEW ProdStats WITH SCHEMABINDING AS
SELECT SpecialOfferID, COUNT_BIG(*) AS #antal, SUM(UnitPrice) AS avgPrice
FROM dbo.sod AS l 
GROUP BY SpecialOfferID
GO

--Skapa index p ovan vy
CREATE UNIQUE CLUSTERED INDEX x ON ProdStats(SpecialOfferID)
GO

SELECT * FROM ProdStats

--Om inte Enterprise Edition
SELECT * FROM ProdStats WITH (NOEXPAND)

--Nedan kostade 10000 I/O frut
SELECT SpecialOfferID, COUNT(*) AS #antal, AVG(UnitPrice) AS avgPrice
FROM dbo.sod AS l 
GROUP BY SpecialOfferID
GO

--Regelverk fr att f skapa index p vy:
-- https://docs.microsoft.com/en-us/sql/relational-databases/views/create-indexed-views?view=sql-server-ver15

