--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

CREATE VIEW dbo.EmployeeName
 AS
SELECT h.BusinessEntityID, p.LastName, p.FirstName
FROM HumanResources.Employee AS h 
  JOIN Person.Person AS p ON h.BusinessEntityID = p.BusinessEntityID;
GO

--Estimated exec plan
SELECT * FROM dbo.EmployeeName;

SELECT h.BusinessEntityID, p.LastName, p.FirstName
FROM HumanResources.Employee AS h 
  JOIN Person.Person AS p ON h.BusinessEntityID = p.BusinessEntityID;

--Accessas bda tabellerna?
SELECT LastName, FirstName FROM dbo.EmployeeName;
--Ja, i dom flesta fall

--Estimated plan fr bda, samtidigt
---------------------------------------------------------------
--Via vy
SELECT LastName AS EmployeeLastName, SalesOrderID, OrderDate
FROM Sales.SalesOrderHeader AS soh
 JOIN dbo.EmployeeName AS EmpN ON (soh.SalesPersonID = EmpN.BusinessEntityID)
WHERE soh.OrderDate > '20020531';

--Referera till Persons och Employee direkt
SELECT LastName AS EmployeeLastName, SalesOrderID, OrderDate
FROM HumanResources.Employee AS e 
 JOIN Sales.SalesOrderHeader AS soh ON soh.SalesPersonID = e.BusinessEntityID
 JOIN Person.Person AS p ON e.BusinessEntityID =p.BusinessEntityID
WHERE soh.OrderDate > '20020531';
--Dom gr samma sak, samma kost, samma plan
---------------------------------------------------------------





















DROP VIEW dbo.EmployeeName;
DROP VIEW IF EXISTS dbo.PersonAddress
GO

--Annan vy
CREATE VIEW dbo.PersonAddress
AS
SELECT p.BusinessEntityID,
       p.LastName,
       p.FirstName,
       bea.AddressTypeID,
       a.City 
FROM Person.Person AS p
 LEFT OUTER JOIN Person.BusinessEntityAddress AS bea ON p.BusinessEntityID = bea.BusinessEntityID 
 LEFT OUTER JOIN Person.Address AS a ON bea.AddressID = a.AddressID;
GO

--Estimated plan
--------------------------------------------------------------------------------
SELECT * 
FROM dbo.PersonAddress

SELECT BusinessEntityID, LastName, FirstName
FROM dbo.PersonAddress;
GO
--------------------------------------------------------------------------------
--Stor skillnad, varfr?

DROP VIEW dbo.PersonAddress;
GO

--------------------------------------------------------------------------------
--Men se hr:
CREATE VIEW dbo.PersonAddress
AS
SELECT p.BusinessEntityID,
       p.LastName,
       p.FirstName,
       bea.AddressTypeID,
       a.City 
FROM Person.Person AS p
 INNER JOIN Person.BusinessEntityAddress AS bea ON p.BusinessEntityID = bea.BusinessEntityID 
 INNER JOIN Person.Address AS a ON bea.AddressID = a.AddressID;
GO
--Inner joins istllet fr outer joins


--Beroende p version s kunde dessa kosta lika mycket!
SELECT * 
FROM dbo.PersonAddress;

SELECT BusinessEntityID,LastName, FirstName
FROM dbo.PersonAddress;
GO



--Fr att uppdatera vydefinitionen
EXEC sp_refreshview 'v'


--Drop view v
DROP VIEW v
