--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

--------------------------------------------------------------------------------------------------------
--Procedur som returnerar ett resultatset
--------------------------------------------------------------------------------------------------------
CREATE PROC Production.GetBlueProducts
AS
SELECT p.ProductID,
     p.Name,
     p.Size,
     p.ListPrice 
FROM Production.Product AS p
WHERE p.Color = N'Blue'
ORDER BY p.ProductID;
GO

EXEC Production.GetBlueProducts;
GO

--------------------------------------------------------------------------------------------------------
--Procedur som returnerar flera resultatset
--------------------------------------------------------------------------------------------------------
CREATE PROC Production.GetBlueProductsAndModels
AS
--Returns two resultsets:
 -- The first bla bla
 -- The second tbla bla
SELECT p.ProductID,
     p.Name,
     p.Size,
     p.ListPrice 
FROM Production.Product AS p
WHERE p.Color = N'Blue'
ORDER BY p.ProductID;

SELECT p.ProductID,
     pm.ProductModelID,
     pm.Name AS ModelName
FROM Production.Product AS p
 INNER JOIN Production.ProductModel AS pm ON p.ProductModelID = pm.ProductModelID 
WHERE p.Color = N'Blue'
ORDER BY p.ProductID, pm.ProductModelID;
GO

EXEC Production.GetBlueProductsAndModels;
GO


--------------------------------------------------------------------------------------------------------
--Vilka procedurer finns det?
--------------------------------------------------------------------------------------------------------
SELECT SCHEMA_NAME(schema_id) AS SchemaName, name AS ProcedureName, *
FROM sys.procedures;
GO



