--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

----------------------------------------------------------------------------------------------------------------------------
--Scalar function
USE Adventureworks
GO

CREATE OR ALTER FUNCTION dbo.EndOfPreviousMonth (@DateToTest date)
RETURNS date
AS
BEGIN
  DECLARE @datetoreturn date
  --SET @datetoreturn = DATEADD(day, 0 - DAY(@DateToTest), @DateToTest)
  SET @datetoreturn = EOMONTH(@DateToTest, -1)
  RETURN @datetoreturn
END;
GO

--Dagens datum
SELECT SYSDATETIME()

--Sist dagen i fregende mnad
SELECT EndOfPreviousMonth(SYSDATETIME()); --Nej, mste ha med schema

SELECT dbo.EndOfPreviousMonth(SYSDATETIME());

SELECT dbo.EndOfPreviousMonth('2010-01-01');

--Anvnd i query
SELECT s.SalesOrderID, s.OrderDate, dbo.EndOfPreviousMonth(s.OrderDate) AS LastDayPrevMonth
FROM Sales.SalesOrderHeader AS s

--Jmfr lsbarhet med om man in-linear uttrycket istllet
SELECT s.SalesOrderID, s.OrderDate, EOMONTH(OrderDate, -1) AS LastDayPrevMonth
FROM Sales.SalesOrderHeader AS s

--Prestanda d?
--Jmfr nedanstende tv i en trace
SELECT MAX(dbo.EndOfPreviousMonth(s.OrderDate)) FROM Sales.SalesOrderHeader AS s
SELECT MAX(CAST(DATEADD(day, 0 - DAY(OrderDate), OrderDate) AS date)) FROM Sales.SalesOrderHeader AS s


--Scalar inlining i 2019
ALTER DATABASE Adventureworks SET COMPATIBILITY_LEVEL = 140
ALTER DATABASE Adventureworks SET COMPATIBILITY_LEVEL = 150
--disabla bara den funtionaliteten
SELECT * FROM sys.database_scoped_configurations WHERE name = 'TSQL_SCALAR_UDF_INLINING'




--r funktionen deterministisk?
SELECT OBJECTPROPERTY(OBJECT_ID('dbo.EndOfPreviousMonth'),'IsDeterministic');

DROP FUNCTION dbo.EndOfPreviousMonth;


----------------------------------------------------------------------------------------------------------------------------
--Se upp fr prestanda, scalar functions kan vara riktiga prestandaddare!
--Bttre i 2019, men inte lika bra som att inte anvnda.
--Se ScalarFnPerf.sql


