--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO


------------------------------------------------------------------------------------------------------------
--Inline TVF
------------------------------------------------------------------------------------------------------------

CREATE OR ALTER FUNCTION Sales.GetLastOrdersForCustomer (@CustomerID int, @NumberOfOrders int)
RETURNS TABLE
AS
RETURN (SELECT TOP(@NumberOfOrders)
                    soh.CustomerID
                   ,soh.SalesOrderID
                   ,soh.OrderDate
                   ,soh.PurchaseOrderNumber
                FROM Sales.SalesOrderHeader AS soh
                WHERE soh.CustomerID = @CustomerID
                ORDER BY soh.OrderDate DESC
               );
GO

SELECT * FROM Sales.GetLastOrdersForCustomer(17288, 2);

SELECT * FROM Sales.Customer

SELECT c.CustomerID, c.PersonID, n.OrderDate, n.PurchaseOrderNumber
FROM Sales.Customer AS c
CROSS APPLY Sales.GetLastOrdersForCustomer(c.CustomerId, 3) AS n

--Med derived table instllet
SELECT c.CustomerID, c.PersonID, n.OrderDate, n.PurchaseOrderNumber
FROM Sales.Customer AS c
CROSS APPLY (SELECT TOP(3)
                    soh.CustomerID
                   ,soh.SalesOrderID
                   ,soh.OrderDate
                   ,soh.PurchaseOrderNumber
                FROM Sales.SalesOrderHeader AS soh
                WHERE soh.CustomerID = c.CustomerID
                ORDER BY soh.OrderDate DESC) AS n

DROP FUNCTION Sales.GetLastOrdersForCustomer;
GO
------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------------
--Multi-Statement TVF
------------------------------------------------------------------------------------------------------------

CREATE OR ALTER FUNCTION dbo.GetDateRange (@StartDate date, @NumberOfDays int)
RETURNS @DateList table (Position int PRIMARY KEY, DateValue date)
AS
 BEGIN
  DECLARE @Counter int=0;
  WHILE (@Counter < @NumberofDays)
    BEGIN
      INSERT INTO @DateList(Position, DateValue )
      VALUES (@Counter + 1, DATEADD (day, @Counter, @StartDate))
      SET @Counter += 1
    END
  RETURN
 END
GO

ALTER DATABASE Adventureworks SET COMPATIBILITY_LEVEL = 150


SELECT * 
FROM dbo.GetDateRange('2009-12-31',140)
