USE Adventureworks

SELECT * FROM Sales.SalesOrderHeader


-----------------------------------------------------------------------------------
--Scalar function, vi kan skapa egan sdana
SELECT s.SalesOrderID, s.OrderDate, s.ShipDate, DATEADD(DAY, 30, s.ShipDate) AS sistaBetalning
FROM Sales.SalesOrderHeader AS s


-----------------------------------------------------------------------------------
--Table/rowset function, vi kan skapa egan sdana
SELECT * 
FROM sys.dm_db_index_physical_stats(NULL, NULL, NULL, NULL, DEFAULT)

--Annat exempel
SELECT *
FROM OPENQUERY(....)

--Ett till
SELECT *
FROM OPENJSON()



-----------------------------------------------------------------------------------
--Aggregate function, kan bara skapa egna i SQL-CLR, dvs INTE i T-SQL
SELECT s.TerritoryID, SUM(s.Freight)
FROM Sales.SalesOrderHeader AS s
GROUP BY s.TerritoryID


-----------------------------------------------------------------------------------
--Windowing, vi kan inte skapa egna sdana
SELECT s.SalesOrderID, s.OrderDate, s.SubTotal,
 RANK() OVER(ORDER BY s.SubTotal)
FROM Sales.SalesOrderHeader AS s
