--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

SELECT TOP(10) * FROM Sales.SalesTerritoryHistory
GO

--Fr inte ta bort rader som r "current"
CREATE TRIGGER TR_SalesTerritoryHistory_Delete
ON Sales.SalesTerritoryHistory
AFTER DELETE
AS
IF @@ROWCOUNT = 0
 RETURN
SET NOCOUNT ON
IF EXISTS
(
  SELECT *
  FROM deleted AS d
  WHERE d.EndDate IS NULL
)
BEGIN
  RAISERROR('Current Sales Territory History rows cannot be deleted', 16, 1)
  ROLLBACK;
END;
GO

SELECT TOP(10) * FROM Sales.SalesTerritoryHistory WHERE BusinessEntityID = 283;

--Testa
DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 283;

SELECT TOP(10) * FROM Sales.SalesTerritoryHistory
WHERE BusinessEntityID = 275 AND StartDate = '2011-05-31T00:00:00.000'

DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 275 AND StartDate = '2011-05-31T00:00:00.000'

SELECT TOP(10) * FROM Sales.SalesTerritoryHistory
WHERE BusinessEntityID = 280 AND StartDate = '2011-05-31 00:00:00.000'

DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 280 AND StartDate = '2011-05-31 00:00:00.000'


--Stda
DROP TRIGGER Sales.TR_SalesTerritoryHistory_Delete;
GO


--Feltnk! Hanterar inte flerradsmodifikationer.
CREATE OR ALTER TRIGGER TR_SalesTerritoryHistory_Delete
ON Sales.SalesTerritoryHistory
AFTER DELETE 
AS
IF @@ROWCOUNT = 0
 RETURN
SET NOCOUNT ON

DECLARE @EndDate date
--SELECT @EndDate = EndDate FROM deleted
SET @EndDate  = (SELECT EndDate FROM deleted)
IF @EndDate IS NULL
BEGIN
  RAISERROR('Current Sales Territory History rows cannot be deleted', 16, 1)
  ROLLBACK;
END;
GO

SELECT TOP(20) * FROM Sales.SalesTerritoryHistory WHERE BusinessEntityID = 283;

--Testa
DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 283;

SELECT TOP(20) * FROM Sales.SalesTerritoryHistory WHERE BusinessEntityID = 277;

DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 277;
GO

--Stda
DROP TRIGGER Sales.TR_SalesTerritoryHistory_Delete;
GO


--Om vi inte klarar av att hantera flerradsmodifikationer, gr frst snygg exit.
CREATE TRIGGER TR_SalesTerritoryHistory_Delete
ON Sales.SalesTerritoryHistory
AFTER DELETE 
AS
IF @@ROWCOUNT > 1
BEGIN
 RAISERROR('Du fr inte ta bort mer n en rad', 16, 1)
 ROLLBACK
 RETURN
END

SET NOCOUNT ON

DECLARE @EndDate date
SET @EndDate = (SELECT EndDate FROM deleted)
IF @EndDate IS NULL
BEGIN
  RAISERROR('Current Sales Territory History rows cannot be deleted', 16, 1)
  ROLLBACK;
END;
GO

SELECT TOP(20) * FROM Sales.SalesTerritoryHistory WHERE BusinessEntityID = 283;

--Testa
DELETE FROM Sales.SalesTerritoryHistory 
WHERE BusinessEntityID = 282;

