--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

SELECT * FROM Sales.SalesOrderHeader
GO

--Tillse att orders med > 10000 i SubTotal har PurchaseOrder nummer
--Detta skulle vi ven kunna gjort med CHECK constraint!!!
CREATE TRIGGER TR_SalesOrderHeader_Insert
ON Sales.SalesOrderHeader
AFTER INSERT AS
SET NOCOUNT ON
IF EXISTS
(
SELECT * 
FROM inserted AS i
WHERE i.SubTotal > 10000
  AND i.PurchaseOrderNumber IS NULL
)
BEGIN;
 --THROW 234532, 'Orders above 10000 must have PO numbers', 1
 RAISERROR('Orders above 10000 must have PO numbers', 16, 1) --Ej PRINT!!!
 ROLLBACK;           
END;
GO


--Testa
INSERT INTO Sales.SalesOrderHeader 
  (RevisionNumber, OrderDate, DueDate, Status, 
   OnlineOrderFlag, PurchaseOrderNumber,
   CustomerID, BillToAddressID, ShipToAddressID, 
   ShipMethodID, SubTotal, TaxAmt, Freight)
  VALUES (1, SYSDATETIME(), SYSDATETIME(), 1,
          1, 'ABC-123',
          4, 3, 3,
          1, 10502, 12, 100)


INSERT INTO Sales.SalesOrderHeader 
  (RevisionNumber, OrderDate, DueDate, Status, 
   OnlineOrderFlag, PurchaseOrderNumber,
   CustomerID, BillToAddressID, ShipToAddressID, 
   ShipMethodID, SubTotal, TaxAmt, Freight)
  VALUES (1, SYSDATETIME(), SYSDATETIME(), 1,
          1, NULL,
          4, 3, 3,
          1, 8000, 12, 100)

SELECT TOP(5) * FROM Sales.SalesOrderHeader ORDER BY OrderDate DESC

INSERT INTO Sales.SalesOrderHeader 
  (RevisionNumber, OrderDate, DueDate, Status, 
   OnlineOrderFlag, PurchaseOrderNumber,
   CustomerID, BillToAddressID, ShipToAddressID, 
   ShipMethodID, SubTotal, TaxAmt, Freight)
  VALUES (1, SYSDATETIME(), SYSDATETIME(), 1,
          1, NULL,
          4, 3, 3,
          1, 18000, 12, 100)

SELECT TOP(5) * FROM Sales.SalesOrderHeader ORDER BY OrderDate DESC

--Stda
DROP TRIGGER Sales.TR_SalesOrderHeader_Insert;


