--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks

DROP TABLE IF EXISTS dbo.CurrentPrice

CREATE TABLE dbo.CurrentPrice
(
	CurrentPriceID int IDENTITY(1,1) 
	  CONSTRAINT PK_CurrentPrice PRIMARY KEY,
	SellingPrice decimal(18,2) NOT NULL,
	LastModified datetime2 NOT NULL
	  CONSTRAINT DF_CurrentPrice_LastModified DEFAULT (SYSDATETIME()),
	ModifiedBy sysname NOT NULL
	  CONSTRAINT DF_CurrentPrice_ModifiedBy DEFAULT (ORIGINAL_LOGIN())
);

INSERT INTO dbo.CurrentPrice (SellingPrice)
  VALUES (2.3), (4.3), (5);


SELECT * FROM dbo.CurrentPrice;

UPDATE dbo.CurrentPrice 
SET SellingPrice = 10 
WHERE CurrentPriceID = 2;


SELECT * FROM dbo.CurrentPrice;
GO

--Trigger som populerar LastModified och ModifiedBy
CREATE TRIGGER TR_CurrentPrice_Update
ON dbo.CurrentPrice
AFTER UPDATE, INSERT AS
SET NOCOUNT ON;
UPDATE dbo.CurrentPrice
SET  LastModified = SYSDATETIME()
    ,ModifiedBy = ORIGINAL_LOGIN()
WHERE CurrentPriceID IN
  (SELECT CurrentPriceID FROM inserted)
GO


--Testa
UPDATE dbo.CurrentPrice 
SET SellingPrice = 20 
WHERE CurrentPriceID = 3;

SELECT * FROM dbo.CurrentPrice;

INSERT INTO dbo.CurrentPrice 
  (SellingPrice)
  VALUES (8888)


SELECT * FROM sys.triggers;

--Stda
DROP TABLE dbo.CurrentPrice;
