--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

USE Adventureworks
GO

ALTER DATABASE Adventureworks SET RECURSIVE_TRIGGERS OFF

DROP TABLE IF EXISTS dbo.SellingPrice
GO

CREATE TABLE dbo.SellingPrice
(
 SellingPriceID int IDENTITY(1,1) PRIMARY KEY
,SubTotal decimal(18,2) NOT NULL
,TaxAmount decimal(18,2) NOT NULL
,FreightAmount decimal(18,2) NOT NULL
,ExtendedAmount decimal(18,2) NULL
);
GO

CREATE TRIGGER TR_SellingPrice_InsertUpdate
ON dbo.SellingPrice
AFTER INSERT, UPDATE
AS
SET NOCOUNT ON;
UPDATE dbo.SellingPrice
SET ExtendedAmount = SubTotal + TaxAmount + FreightAmount
WHERE SellingPriceID IN
  (SELECT SellingPriceID FROM inserted)
GO


INSERT INTO dbo.SellingPrice  (SubTotal, TaxAmount, FreightAmount)
					   VALUES (12.3, 1.23, 10), (5, 1, 2);

SELECT * FROM dbo.SellingPrice;
 
DROP TABLE dbo.SellingPrice;
GO

--Computed column istllet
CREATE TABLE dbo.SellingPrice
(
 SellingPriceID int IDENTITY(1,1) PRIMARY KEY
,SubTotal decimal(18,2) NOT NULL
,TaxAmount decimal(18,2) NOT NULL
,FreightAmount decimal(18,2) NOT NULL
,ExtendedAmount AS (SubTotal + TaxAmount + FreightAmount) PERSISTED --OBS
);
GO

INSERT INTO dbo.SellingPrice (SubTotal, TaxAmount, FreightAmount)
  VALUES (12.3, 1.23, 10), (5, 1, 2);


SELECT * FROM dbo.SellingPrice;


--Stda
DROP TABLE dbo.SellingPrice;
GO

