--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

--Rekursiv trigger

USE Adventureworks
SET NOCOUNT ON

--terstll
ALTER DATABASE Adventureworks SET RECURSIVE_TRIGGERS OFF
IF OBJECT_ID('anstllda') IS NOT NULL DROP TABLE anstllda
IF OBJECT_ID('populateTable') IS NOT NULL DROP PROC populateTable
GO

--Skapa tabell
CREATE TABLE anstllda(anst_no int PRIMARY KEY, namn varchar(30), chef int)
GO

--Skapa procedur some populerar tabellen
CREATE PROC populateTable AS
TRUNCATE TABLE anstllda
INSERT INTO anstllda (anst_no, namn, chef) VALUES(1, 'Kalle', 1)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(2, 'Steve', 1)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(3, 'Lisa', 1)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(4, 'John', 2)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(5, 'Sue', 2)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(6, 'Erik', 3)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(7, 'Fred', 4)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(8, 'Tom', 4)
INSERT INTO anstllda (anst_no, namn, chef) VALUES(9, 'Susan', 5)
GO

EXEC populateTable

--Hur ser det ut?
SELECT * FROM anstllda ORDER BY anst_no
GO

--Skapa trigger
CREATE TRIGGER no_orphans
ON anstllda
AFTER DELETE
AS
DELETE FROM anstllda WHERE chef IN(SELECT anst_no FROM Deleted)
GO


--Amerikanska sektionen sljs
DELETE FROM anstllda WHERE anst_no = 2

--Hur blev det?
SELECT * FROM anstllda ORDER BY anst_no

--Fixa s det blir rtt
ALTER DATABASE Adventureworks SET RECURSIVE_TRIGGERS ON

--Populera om tabellen
EXEC populateTable

--Hur ser det ut?
SELECT * FROM anstllda ORDER BY anst_no

--Amerikanska sektionen sljs
DELETE FROM anstllda WHERE anst_no = 2

--Hur blev det?
SELECT * FROM anstllda ORDER BY anst_no

--Vi glmde avsluta rekursionen...
DROP TRIGGER no_orphans
GO

--Korrekt trigger
CREATE TRIGGER no_orphans
ON anstllda
AFTER DELETE
AS
IF @@ROWCOUNT = 0 RETURN
DELETE FROM anstllda WHERE chef IN(SELECT anst_no FROM Deleted)
GO

--Hur ser det ut?
SELECT * FROM anstllda ORDER BY anst_no

--Amerikanska sektionen sljs
DELETE FROM anstllda WHERE anst_no = 2

--Hur blev det?
SELECT * FROM anstllda ORDER BY anst_no

ALTER DATABASE Adventureworks SET RECURSIVE_TRIGGERS OFF
