--Copyright Tibor Karaszi Konsulting. Not to be used by other than Tibor Karaszi for educational purposes.

----------------------
--Autocommit
UPDATE ...

DELETE ...

INSERT ...
GO

BEGIN TRAN
	UPDATE ...
	DELETE ...
	INSERT ...
COMMIT --ROLLBACK

----------------------
--Explicit transaktion
BEGIN TRY
	BEGIN TRAN
		UPDATE ...
		DELETE ...
		INSERT ...
	COMMIT 
END TRY
BEGIN CATCH
	RAISERROR('Fel', 16, 1)
	SELECT ERROR_MESSAGE(), ERROR_NUMBER()
	ROLLBACK
END CATCH


----------------------
BEGIN TRAN
	UPDATE ...
	DELETE ... --Fail
	INSERT ...
COMMIT 
----------------------


----------------------
--
SET XACT_ABORT ON
BEGIN TRAN
	UPDATE ...
	DELETE ...
	INSERT ...
COMMIT 
GO

--Tips: https://www.sommarskog.se/error_handling/Part1.html

----------------------
--Implicit transactions (sl av autocommit) Gr att defaulta p i SSMS, Tools, Options
SET IMPLICIT_TRANSACTIONS ON
DELETE --nu har transaktion pbrjats
ROLLBACK --COMMIT


----------------------
--Namn p transaktion (vrdelst)
BEGIN TRAN Kalle --Kan inte anvnda namnet till nt

----------------------
--Nstlade transaktioner, stds bara i syntax (inte sematik)
SELECT @@TRANCOUNT

BEGIN TRAN -- +1 , 1
INSERT
  BEGIN TRAN -- +1 , 2
   DELETE
  COMMIT -- -1 , 1
DELETE
COMMIT -- -1 , 0


BEGIN TRAN -- +1 , 1
INSERT
  BEGIN TRAN -- +1 , 2
   DELETE
  ROLLBACK -- -> 0 , 0
DELETE
ROLLBACK -- -> 0 , 0 (failar)

